# coding: utf-8

"""
    Cythereal MAGIC API

    The API for accessing Cythereal MAGIC products and services.  # API Conventions  Properties MUST be named using `snake_case`.  This API is inspired by the [google json style guide](https://google.github.io/styleguide/jsoncstyleguide.xml). Any questions about conventions not documented here should be addressed by this style guide.  **All responses** MUST be of type `APIResponse` and contain the following fields:  * `api_version` |  The current api version * `success` | Boolean value indicating if the operation succeeded. * `code` | Status code. Typically corresponds to the HTTP status code.  * `message` | A human readable message providing more details about the operation. Can be null or empty.  **Successful operations** MUST return a `SuccessResponse`, which extends `APIResponse` by adding:  * `data` | Properties containing the response object. * `success` | MUST equal True  When returning objects from a successful response, the `data` object SHOULD contain a property named after the requested object type. For example, the `/matches` endpoint should return a response object with `data.matches`. This property SHOULD  contain a list of the returned objects. For the `/matches` endpoint, the `data.matches` property contains a list of MagicMatch objects. See the `/matches` endpoint documentation for an example.  **Failed Operations** MUST return an `ErrorResponse`, which extends `APIResponse` by adding:  * `errors` | Array of error objects. An error object contains the following properties:     * `ErrorObject.reason` | Unique identifier for this error. Example: \"FileNotFoundError\".     * `ErrorObject.message`| Human readable error message. * `success` | MUST equal False.   # Example Inputs  Here are some example inputs that can be used for testing the service:  * Binary SHA1: `ff9790d7902fea4c910b182f6e0b00221a40d616`   * Can be used for `file_hash` parameters. * Procedure RVA: `0x1000`   * Use with the above SHA1 for `proc_rva` parameters.   # noqa: E501

    OpenAPI spec version: 1
    Contact: support@cythereal.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from cythereal_magic.models.magic_categories import MagicCategories  # noqa: F401,E501
from cythereal_magic.models.magic_report_detection_stats import MagicReportDetectionStats  # noqa: F401,E501
from cythereal_magic.models.md5 import MD5  # noqa: F401,E501
from cythereal_magic.models.sha1 import SHA1  # noqa: F401,E501
from cythereal_magic.models.sha256 import SHA256  # noqa: F401,E501
from cythereal_magic.models.sha512 import SHA512  # noqa: F401,E501


class MagicReport(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'sha1': 'SHA1',
        'sha256': 'SHA256',
        'sha512': 'SHA512',
        'md5': 'MD5',
        'unix_file_type': 'str',
        'first_seen': 'str',
        'categories': 'MagicCategories',
        'tags': 'list[str]',
        'detection_stats': 'MagicReportDetectionStats',
        'av_names': 'list[str]'
    }

    attribute_map = {
        'sha1': 'sha1',
        'sha256': 'sha256',
        'sha512': 'sha512',
        'md5': 'md5',
        'unix_file_type': 'unix_file_type',
        'first_seen': 'first_seen',
        'categories': 'categories',
        'tags': 'tags',
        'detection_stats': 'detection_stats',
        'av_names': 'av_names'
    }

    def __init__(self, sha1=None, sha256=None, sha512=None, md5=None, unix_file_type=None, first_seen=None, categories=None, tags=None, detection_stats=None, av_names=None):  # noqa: E501
        """MagicReport - a model defined in Swagger"""  # noqa: E501

        self._sha1 = None
        self._sha256 = None
        self._sha512 = None
        self._md5 = None
        self._unix_file_type = None
        self._first_seen = None
        self._categories = None
        self._tags = None
        self._detection_stats = None
        self._av_names = None
        self.discriminator = None

        if sha1 is not None:
            self.sha1 = sha1
        if sha256 is not None:
            self.sha256 = sha256
        if sha512 is not None:
            self.sha512 = sha512
        if md5 is not None:
            self.md5 = md5
        if unix_file_type is not None:
            self.unix_file_type = unix_file_type
        if first_seen is not None:
            self.first_seen = first_seen
        if categories is not None:
            self.categories = categories
        if tags is not None:
            self.tags = tags
        if detection_stats is not None:
            self.detection_stats = detection_stats
        if av_names is not None:
            self.av_names = av_names

    @property
    def sha1(self):
        """Gets the sha1 of this MagicReport.  # noqa: E501


        :return: The sha1 of this MagicReport.  # noqa: E501
        :rtype: SHA1
        """
        return self._sha1

    @sha1.setter
    def sha1(self, sha1):
        """Sets the sha1 of this MagicReport.


        :param sha1: The sha1 of this MagicReport.  # noqa: E501
        :type: SHA1
        """

        self._sha1 = sha1

    @property
    def sha256(self):
        """Gets the sha256 of this MagicReport.  # noqa: E501


        :return: The sha256 of this MagicReport.  # noqa: E501
        :rtype: SHA256
        """
        return self._sha256

    @sha256.setter
    def sha256(self, sha256):
        """Sets the sha256 of this MagicReport.


        :param sha256: The sha256 of this MagicReport.  # noqa: E501
        :type: SHA256
        """

        self._sha256 = sha256

    @property
    def sha512(self):
        """Gets the sha512 of this MagicReport.  # noqa: E501


        :return: The sha512 of this MagicReport.  # noqa: E501
        :rtype: SHA512
        """
        return self._sha512

    @sha512.setter
    def sha512(self, sha512):
        """Sets the sha512 of this MagicReport.


        :param sha512: The sha512 of this MagicReport.  # noqa: E501
        :type: SHA512
        """

        self._sha512 = sha512

    @property
    def md5(self):
        """Gets the md5 of this MagicReport.  # noqa: E501


        :return: The md5 of this MagicReport.  # noqa: E501
        :rtype: MD5
        """
        return self._md5

    @md5.setter
    def md5(self, md5):
        """Sets the md5 of this MagicReport.


        :param md5: The md5 of this MagicReport.  # noqa: E501
        :type: MD5
        """

        self._md5 = md5

    @property
    def unix_file_type(self):
        """Gets the unix_file_type of this MagicReport.  # noqa: E501

        Unix file type of the file.  # noqa: E501

        :return: The unix_file_type of this MagicReport.  # noqa: E501
        :rtype: str
        """
        return self._unix_file_type

    @unix_file_type.setter
    def unix_file_type(self, unix_file_type):
        """Sets the unix_file_type of this MagicReport.

        Unix file type of the file.  # noqa: E501

        :param unix_file_type: The unix_file_type of this MagicReport.  # noqa: E501
        :type: str
        """

        self._unix_file_type = unix_file_type

    @property
    def first_seen(self):
        """Gets the first_seen of this MagicReport.  # noqa: E501

        Timestamp of when this file was first uploaded to MAGIC  # noqa: E501

        :return: The first_seen of this MagicReport.  # noqa: E501
        :rtype: str
        """
        return self._first_seen

    @first_seen.setter
    def first_seen(self, first_seen):
        """Sets the first_seen of this MagicReport.

        Timestamp of when this file was first uploaded to MAGIC  # noqa: E501

        :param first_seen: The first_seen of this MagicReport.  # noqa: E501
        :type: str
        """

        self._first_seen = first_seen

    @property
    def categories(self):
        """Gets the categories of this MagicReport.  # noqa: E501


        :return: The categories of this MagicReport.  # noqa: E501
        :rtype: MagicCategories
        """
        return self._categories

    @categories.setter
    def categories(self, categories):
        """Sets the categories of this MagicReport.


        :param categories: The categories of this MagicReport.  # noqa: E501
        :type: MagicCategories
        """

        self._categories = categories

    @property
    def tags(self):
        """Gets the tags of this MagicReport.  # noqa: E501

        List of tags added to this binary.  # noqa: E501

        :return: The tags of this MagicReport.  # noqa: E501
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this MagicReport.

        List of tags added to this binary.  # noqa: E501

        :param tags: The tags of this MagicReport.  # noqa: E501
        :type: list[str]
        """

        self._tags = tags

    @property
    def detection_stats(self):
        """Gets the detection_stats of this MagicReport.  # noqa: E501


        :return: The detection_stats of this MagicReport.  # noqa: E501
        :rtype: MagicReportDetectionStats
        """
        return self._detection_stats

    @detection_stats.setter
    def detection_stats(self, detection_stats):
        """Sets the detection_stats of this MagicReport.


        :param detection_stats: The detection_stats of this MagicReport.  # noqa: E501
        :type: MagicReportDetectionStats
        """

        self._detection_stats = detection_stats

    @property
    def av_names(self):
        """Gets the av_names of this MagicReport.  # noqa: E501

        List of names assigned to this binary by a Multi-Scanner.  # noqa: E501

        :return: The av_names of this MagicReport.  # noqa: E501
        :rtype: list[str]
        """
        return self._av_names

    @av_names.setter
    def av_names(self, av_names):
        """Sets the av_names of this MagicReport.

        List of names assigned to this binary by a Multi-Scanner.  # noqa: E501

        :param av_names: The av_names of this MagicReport.  # noqa: E501
        :type: list[str]
        """

        self._av_names = av_names

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MagicReport):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
